<html data-namespace-typo3-fluid="true" xmlns:f="http://typo3.org/ns/TYPO3/CMS/Fluid/ViewHelpers"
	  xmlns:osmmap="http://typo3.org/ns/Typo3graf/LeafletOsm/ViewHelpers">
<osmmap:script>

	// Initialization

	var map = L.tileLayer.provider('OpenStreetMap.DE'),
	sat = L.tileLayer.provider('Esri.WorldImagery'),
	ter = L.tileLayer.provider('OpenTopoMap'),
	hyb_base = L.tileLayer.provider('Esri.WorldImagery'),
	hybrid_overlay = L.tileLayer.provider('Hydda.RoadsAndLabels');

	var defaultType = <f:format.raw>{</f:format.raw>
	0 : 'OpenStreetMap.DE',
	1 : 'Esri.WorldImagery',
	2 : 'OpenTopoMap'
	<f:format.raw>}</f:format.raw>

	var defaultLayer = <f:format.raw>{</f:format.raw>
	0 : map,
	1 : sat,
	2 : ter,
	3 : hyb_base
	<f:format.raw>}</f:format.raw>

	var travelMode = <f:format.raw>{</f:format.raw>
	0 : 'driving-car',
	1 : 'cycling-regular',
	2 : 'foot-walking'
	<f:format.raw>}</f:format.raw>

	var units = <f:format.raw>{</f:format.raw>
	0 : 'm',
	1 : 'mi'
	<f:format.raw>}</f:format.raw>
// TODO Translate Maplayer names
	var baseMaps = <f:format.raw>{</f:format.raw>
	<f:for each="{mapTypes}" as="type" iteration="i">
		{f:if(condition:"{type} == 0", then:"\"{f:translate(key:'tx_lefaletosm_partials_map_assign.mapLayer_Map')}\": map,", else:"")}
		{f:if(condition:"{type} == 1", then:"\"{f:translate(key:'tx_lefaletosm_partials_map_assign.mapLayer_Satellite')}\": sat,", else:"")}
		{f:if(condition:"{type} == 2", then:"\"{f:translate(key:'tx_lefaletosm_partials_map_assign.mapLayer_Terrain')}\": ter,", else:"")}
		{f:if(condition:"{type} == 3", then:"\"{f:translate(key:'tx_lefaletosm_partials_map_assign.mapLayer_Hybrid')}\": hyb_base,", else:"")}
	</f:for>
	<f:format.raw>}</f:format.raw>;

	var markerList = [];

	// map privat functions

	// customGetLayer
	L.LayerGroup.include(<f:format.raw>{</f:format.raw>
	customGetLayer: function (id) <f:format.raw>{</f:format.raw>
	for (var i in this._layers) <f:format.raw>{</f:format.raw>
	if (this._layers[i].options.id == id) <f:format.raw>{</f:format.raw>
	return this._layers[i];
	<f:format.raw>}</f:format.raw>
	<f:format.raw>}</f:format.raw>
	<f:format.raw>}</f:format.raw>
	<f:format.raw>}</f:format.raw>);

	// Init & Create Map

	var osmmap{map.uid} = L.map('osm-{map.uid}',<f:format.raw>{</f:format.raw>
	zoomControl: 0,
	scrollWheelZoom: {f:if(condition:"{map.scrollZoom}", then:"{map.scrollZoom}", else:"0")},
	dragging: {f:if(condition:"{map.draggable}", then:"{map.draggable}", else:"0")},
	doubleClickZoom: {f:if(condition:"{map.doubleClickZoom}", then:"{map.doubleClickZoom}", else:"0")},
	<f:if condition="{map.mapTypeControl}">layers: defaultLayer[{map.defaultType}]</f:if>
	<f:format.raw>}</f:format.raw>);

	// init Map View
	osmmap{map.uid}.setView([{map.centerLatitude},{map.centerLongitude}], {map.zoom});

	// Map Controller


	// Zoom settings
	<f:if condition="{map.minZoom}>0">
		osmmap{map.uid}.options.minZoom = {map.minZoom};
	</f:if>
	<f:if condition="{map.maxZoom}>0">
		osmmap{map.uid}.options.maxZoom = {map.maxZoom};
	</f:if>
	<f:if condition="{map.centerLatitude} == 0 || {map.centerLongitude} == 0">
		// Auto center map
		osmmap{map.uid}.fitBounds([{boundsCode}]);
		osmmap{map.uid}.setZoom('{map.zoom}');
	</f:if>
	<f:if condition="{map.kmlUrl}">
		// KML File
		var track = new L.KML('{map.kmlUrl}', <f:format.raw>{</f:format.raw>async: true<f:format.raw>}</f:format.raw>);
		track.on("loaded", function(e) {
		<f:if condition="!{map.kmlPreserveViewport}">osmmap{map.uid}.fitBounds(e.target.getBounds());</f:if>
		});
		osmmap{map.uid}.addLayer(track);
	</f:if>
	<f:if condition="{map.zoomControl}">
		// Zoom control
		L.control.zoom(<f:format.raw>{</f:format.raw>
		zoomInTitle: '<f:translate key="LLL:EXT:leaflet_osm/Resources/Private/Language/locallang.xlf:tx_lefaletosm_partials_map_assign.zoom_zoomInTitle" />',
		zoomOutTitle: '<f:translate key="LLL:EXT:leaflet_osm/Resources/Private/Language/locallang.xlf:tx_lefaletosm_partials_map_assign.zoom_zoomOutTitle" />',
		<f:format.raw>}</f:format.raw>).addTo(osmmap{map.uid});
	</f:if>
	<f:if condition="{map.geoLocation}">
		// Geolocation
		L.control.locate(<f:format.raw>{</f:format.raw>
		icon:'fas fa-map-marker-alt geolocation-icon',
		drawCircle: true,
		strings: <f:format.raw>{</f:format.raw>
		title: '<f:translate key="LLL:EXT:leaflet_osm/Resources/Private/Language/locallang.xlf:tx_lefaletosm_partials_map_assign.geoLocation_title" />',
		metersUnit: '<f:translate key="LLL:EXT:leaflet_osm/Resources/Private/Language/locallang.xlf:tx_lefaletosm_partials_map_assign.geoLocation_metersUnit" />',
		feetUnit: '<f:translate key="LLL:EXT:leaflet_osm/Resources/Private/Language/locallang.xlf:tx_lefaletosm_partials_map_assign.geoLocation_feetUnit" />',
		popup: '<f:translate key="LLL:EXT:leaflet_osm/Resources/Private/Language/locallang.xlf:tx_lefaletosm_partials_map_assign.geoLocation_popup" />',
		outsideMapBoundsMsg: '<f:translate key="LLL:EXT:leaflet_osm/Resources/Private/Language/locallang.xlf:tx_lefaletosm_partials_map_assign.geoLocation_outsideMapBoundsMsg" />'
		<f:format.raw>}</f:format.raw>,
		<f:format.raw>}</f:format.raw>).addTo(osmmap{map.uid});
	</f:if>



	// Map controllers

	// Scale control
	<f:if condition="{map.scalecontrol}">
		L.control.scale().addTo(osmmap{map.uid});
	</f:if>

	// Fullscreen controll
	<f:if condition="{map.FullScreenControl}">
		//Fullscreen
		L.control.fullscreen(<f:format.raw>{</f:format.raw>
		position: 'topleft',
		title: '<f:translate key="LLL:EXT:leaflet_osm/Resources/Private/Language/locallang.xlf:tx_lefaletosm_partials_map_assign.fullscreen_title" />',
		titleCancel: '<f:translate key="LLL:EXT:leaflet_osm/Resources/Private/Language/locallang.xlf:tx_lefaletosm_partials_map_assign.fullscreen_titleCancel" />',
		content: null,
		forceSeparateButton: true,
		<f:format.raw>}</f:format.raw>).addTo(osmmap{map.uid});
	</f:if>

	// Special map functions
	// listen for hybrid map
	osmmap{map.uid}.on('baselayerchange', function(eo)
	<f:format.raw>{</f:format.raw>
	if( eo.name == '{f:translate(key:'tx_lefaletosm_partials_map_assign.mapLayer_Hybrid')}' ) <f:format.raw>{</f:format.raw>
	osmmap{map.uid}.addLayer(hybrid_overlay);
	hybrid_overlay.bringToFront();
	<f:format.raw>}</f:format.raw>
	else <f:format.raw>{</f:format.raw>
	osmmap{map.uid}.removeLayer(hybrid_overlay);
	<f:format.raw>}</f:format.raw>
	<f:format.raw>}</f:format.raw>);


	( function ( $ ) <f:format.raw>{</f:format.raw>
	$.fn.showOsmMap = function () <f:format.raw>{</f:format.raw>
	<f:if condition="{map.mapTypeControl}">
		<f:then>layerControl = L.control.layers(baseMaps,null,<f:format.raw>{</f:format.raw>collapsed: false<f:format.raw>}</f:format.raw>).addTo(osmmap{map.uid});</f:then>
		<f:else>
			L.tileLayer.provider(defaultType[{map.defaultType}]).addTo(osmmap{map.uid});
		</f:else>
	</f:if>
	// Markers & addresses interaction

	// Initial markers

	<f:if condition="{map.markerCluster}">
		<f:then>
			var markers = L.markerClusterGroup(<f:format.raw>{</f:format.raw>
			spiderfyOnMaxZoom: false,
			showCoverageOnHover: false,
			disableClusteringAtZoom: {map.markerClusterZoom},
			maxClusterRadius: {map.markerClusterSize}
			<f:format.raw>}</f:format.raw>);

		</f:then>
		<f:else>
			var markers = L.featureGroup();
		</f:else>
	</f:if>

	<f:if condition="{map.showCategories}">
		// Initial Categories
		<f:if condition="!{map.mapTypeControl}">
			layerControl = L.control.layers(null,null, <f:format.raw>{</f:format.raw>collapsed: false<f:format.raw>}</f:format.raw>);
		</f:if>
		<f:for each="{categories}" as="category">
			var cat{category.uid} = L.featureGroup.subGroup(markers);
			layerControl.addOverlay(cat{category.uid}, '{category.title}');
			cat{category.uid}.addTo(osmmap{map.uid});
			<f:if condition="{category.osmMarker}">
				// category marker icon
				var cat{category.uid}Icon = L.icon(<f:format.raw>{</f:format.raw>
				iconUrl: '{f:uri.image(src:category.osmMarker.originalResource.publicUrl,absolute:1)}',
				iconSize: [{category.osmImageWidth}, {category.osmImageHeight}],
				iconAnchor: [{category.osmMarkerAnchorX}, {category.osmMarkerAnchorY}],
				popupAnchor: [{category.osmPopupAnchorX}, -{category.osmPopupAnchorY}],
				<f:format.raw>}</f:format.raw>);
			</f:if>

		</f:for>
		layerControl.addTo(osmmap{map.uid});

	</f:if>

	<f:for each="{addresses}" as="address">
		<f:if condition="{address.marker}">
			// address marker icon
			var marker{address.uid}Icon = L.icon(<f:format.raw>{</f:format.raw>
			iconUrl: '{f:uri.image(src:address.marker.originalResource.publicUrl,absolute:1)}',
			iconSize: [{address.imageWidth}, {address.imageHeight}],
			iconAnchor: [{address.markerAnchorX}, {address.markerAnchorY}],
			popupAnchor: [{address.popupAnchorX}, -{address.popupAnchorY}],
			<f:format.raw>}</f:format.raw>);
		</f:if>
		var marker{address.uid} = L.marker([{address.latitude}, {address.longitude}],<f:format.raw>{</f:format.raw>
		title: '{address.title}',
		id:{address.uid}
		<f:format.raw>}</f:format.raw>);
		<f:if condition="{address.infoWindowContent}">marker{address.uid}.bindPopup('<f:format.raw><osmmap:escape><f:render partial="Map/InfoWindow" arguments="{_all}" /></osmmap:escape></f:format.raw>',<f:format.raw>{</f:format.raw>maxWidth:500, maxHeight:500<f:format.raw>}</f:format.raw>);</f:if>
		<f:if condition="{map.showCategories} && {address.categories}">
			<f:then>
				<f:for each="{address.categories}" as="category">
					<f:if condition="{category.osmMarker}">marker{address.uid}.setIcon(cat{category.uid}Icon);</f:if>
					<f:if condition="{address.marker}">marker{address.uid}.setIcon(marker{address.uid}Icon);</f:if>
					marker{address.uid}.addTo(cat{category.uid});
				</f:for>
			</f:then>
			<f:else>
				<f:if condition="{address.marker}">marker{address.uid}.setIcon(marker{address.uid}Icon);</f:if>
				marker{address.uid}.addTo(markers);
			</f:else>
		</f:if>
		markerList.push(marker{address.uid});
		<f:if condition="!{address.openByClick}">
			marker{address.uid}.on('mouseover',function(ev) <f:format.raw>{</f:format.raw>
			ev.target.openPopup();
			<f:format.raw>}</f:format.raw>);
		</f:if>

		<f:if condition="!{address.closeByClick}">
		marker{address.uid}.on('mouseout',function(ev) <f:format.raw>{</f:format.raw>
		ev.target.closePopup();
		<f:format.raw>}</f:format.raw>);
		</f:if>
	</f:for>
	markers.addTo(osmmap{map.uid});
	<f:for each="{addresses}" as="address">
	<f:if condition="{address.opened}">
		marker{address.uid}.openPopup();
	</f:if>
	</f:for>
	// Overlay Title
	<f:if condition="{map.showCategories}">$(".leaflet-control-layers-overlays").prepend("<label><b><f:translate key="LLL:EXT:leaflet_osm/Resources/Private/Language/locallang.xlf:tx_lefaletosm_partials_map_assign.map_categories" /></b></label>");</f:if>



	// Calc route
	<f:if condition="{map.calcRoute}">
		// Routing
		mapRouter = L.Routing.control(<f:format.raw>{</f:format.raw>
		waypoints: [
		,
		<f:if condition="!{map.showRoute}">[markerList[0]._latlng.lat, markerList[0]._latlng.lng]</f:if>
		],
		collapsible: true,
		showAlternatives: true,
		collapsed: true,
		language: 'de-DE',
		routeWhileDragging: false,
		router: new L.Routing.openrouteservice('{settings.apiKey}', <f:format.raw>{</f:format.raw>urlParameters: <f:format.raw>{</f:format.raw>profile: travelMode[{map.travelMode}], language: 'de', units: units[{map.measureSystem}]<f:format.raw>}</f:format.raw><f:format.raw>}</f:format.raw>),
		geocoder: L.Control.Geocoder.nominatim()
		<f:format.raw>}</f:format.raw>).addTo(osmmap{map.uid});
	</f:if>

	// Marker search
	<f:if condition="{map.markerSearch}">
		var controlSearch = new L.Control.Search(<f:format.raw>{</f:format.raw>
		position:'topleft',
		layer: markers,
		initial: false,
		autoCollapse: true,
		zoom: 17,
		marker: false,
		textPlaceholder: '<f:translate key="LLL:EXT:leaflet_osm/Resources/Private/Language/locallang.xlf:tx_lefaletosm_partials_map_assign.markerSearch_placeholder" />',
		textCancel: '<f:translate key="LLL:EXT:leaflet_osm/Resources/Private/Language/locallang.xlf:tx_lefaletosm_partials_map_assign.markerSearch_cancel" />',
		<f:format.raw>}</f:format.raw>);
		osmmap{map.uid}.addControl( controlSearch );
	</f:if>

	// Address Links
	$('.js-osm{map.uid}-address').click(function () <f:format.raw>{</f:format.raw>
	var data_marker = [$(this).attr('data-marker')];

	<f:if condition="{map.markerCluster}">
		<f:then>
			for (i = 0; i < markerList.length; i++) <f:format.raw>{</f:format.raw>
			if (markerList[i].options.id == data_marker) <f:format.raw>{</f:format.raw>
			var m = markerList[i];

			<f:format.raw>}</f:format.raw>
			<f:format.raw>}</f:format.raw>
			markers.zoomToShowLayer(m, function () <f:format.raw>{</f:format.raw>
			m.openPopup();
			//TODO mapRouter change target
			<f:format.raw>}</f:format.raw>);
		</f:then>
		<f:else>
			var layer = markers.customGetLayer(data_marker);
			osmmap{map.uid}.setView([layer.getLatLng().lat, layer.getLatLng().lng], 18);
			//TODO mapRouter change target
			layer.fire("click");
		</f:else>
	</f:if>

	<f:format.raw>}</f:format.raw>);

	<f:format.raw>}</f:format.raw>
	<f:format.raw>}</f:format.raw> ) ( jQuery );


	<f:if condition="!{settings.preview.enabled}">
		$('.js-osm-container').showOsmMap();
	</f:if>
</osmmap:script>
